import { api } from '@/utils'


export const RECEIVE_MY_COURSES = 'RECEIVE_MY_COURSES'
export const receiveMyCourses = payload => ({
    type: RECEIVE_MY_COURSES,
    payload
})


const PAGE_INTERVAL = 1
export const NUM_INTERVAL = 10
export const fetchCoursesListIfNeeded = () => (dispatch, getState) => {
    const myCourses = getState().myCourses
    const {shouldFetch, page} = myCourses
    if (shouldFetch) {
        dispatch(getMyCourses({
            page: page + PAGE_INTERVAL,
            num: NUM_INTERVAL
        }))
    }
}

export const getMyCourses = payload => dispatch => {
    return api.get(`/m/my_course/${payload.page}/${payload.num}`)
        .then(res => {
            const {data,code,msg} = res.data
            dispatch(receiveMyCourses({
                courseList: data,
                statusCode: code,
                msg: msg,
                page: payload.page,
                num: payload.num
            }))
            dispatch(invalidateCourseDate())
        })
}

export const INVALIDATE_COURSEDATA = 'INVALIDATE_COURSEDATA'
export const invalidateCourseDate = () => ({
    type: INVALIDATE_COURSEDATA
})

export const VALIDATE_COURSEDATA = 'VALIDATE_COURSEDATA'
export const validateCourseData = () => ({
    type: VALIDATE_COURSEDATA
})
